#!/bin/bash

SOCKET_PATH="/tmp/demosocket"

# Cleanup function to be run on exit
cleanup() {
    echo "Cleaning up..."
    if [[ -n "$SERVER_PID" ]]; then
        kill "$SERVER_PID" 2>/dev/null || true
        wait "$SERVER_PID" 2>/dev/null || true
    fi
    rm -f "$SOCKET_PATH"
}

# Trap EXIT to ensure cleanup runs
trap cleanup EXIT

echo "Starting server..."
./server.elf &
SERVER_PID=$!

# Wait briefly for the server to start
sleep 0.2

echo "Running client..."
./client.elf
